# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz>
"""
$Id: ForumContentTopic.py,v 1.25 2004/03/26 10:11:55 fafhrd91 Exp $
"""

import random, traceback
from Acquisition import aq_parent, aq_base
from Products.Archetypes.public import *
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.config import TOOL_NAME as ARCHETYPE_TOOL
from Products.Archetypes.interfaces.referenceable import IReferenceable

from config import *
from utils import forum_parser
from ForumTopic import ForumTopic
from debug import log_exc

class ForumContentTopic(ForumTopic):
    """ """
    meta_type = 'ForumContentTopic'
    archetype_name = 'Forum Content Topic'

    global_allow = 0
    filter_content_types = 1
    allowed_content_types = []

    security = ClassSecurityInfo()

    topic_type = 1

    content_uid = 0
    content_path = ''

    def _get_content(self):
        obs = self.getRefs('cmfboard_topic')
        if obs:
            return obs[0].getContent()
        else:
            return None

    def initializeArchetype(self, **kwargs):
        if kwargs.has_key('content_uid'):
            # link to DiscussionContainer
            obj = self.archetype_tool.lookupObject(kwargs['content_uid'])
            self.addReference(obj, 'cmfboard_topic')

        ForumTopic.initializeArchetype(self, **kwargs)

    security.declareProtected(View, 'Title')
    def Title(self):
        """ """
        try:
            ob = self._get_content()
            return ob.Title()
        except:
            return 'Broken content!!!'

    security.declareProtected(View, 'Description')
    def Description(self):
        """ """
        try:
            ob = self._get_content()
            return ob.Description()
        except:
            return ''

    security.declareProtected(View, 'CookedBody')
    def CookedBody(self):
        """ """
        try:
            ob = self._get_content()
            if hasattr(aq_base(ob), 'CookedBody'):
                return ob.CookedBody()
            
            elif hasattr(aq_base(ob), 'getField'):
                return ob.getField('text').get(ob, mimetype='text/html')

            content = 'original: [url=%s urltitle=%s][/url] \n %s'% (
                ob.absolute_url(), getattr(aq_base(ob), 'title', ''),
                ob.Description())
            return forum_parser(self, content)
        except:
            log_exc("Can't find content")
            return "Can't find content"

    security.declareProtected(View, 'EditableBody')
    def EditableBody(self, mimetype='text/plain'):
        """ """
        try:
            ob = self._get_content()
            try:
                field = ob.getField('text')
                if field is not None:
                    return field.get(ob, mimetype=mimetype)
            except:
                pass
            return ob.EditableBody()
        except:
            return self.CookedBody()

    security.declareProtected(View, 'getText')
    def getText(self, mimetype='text/plain'):
        """ """
        return self.EditableBody(mimetype)


registerType(ForumContentTopic)


def modify_fti(fti):
    for a in fti['actions']:
        if a['id'] in ('references', 'metadata', 'edit'):
            a['visible'] = 0
    return fti
