# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz> 
"""
$Id: ForumFolder.py,v 1.27 2004/03/31 07:45:57 fafhrd91 Exp $
"""

import traceback
from Acquisition import aq_base, aq_parent
from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from Products.Archetypes.public import *
try:
    from Products.Archetypes.config import UUID_ATTR
except:
    UUID_ATTR = '_uid'

from UserPreferences import UserPreferences

class ForumFolder(OrderedBaseFolder, UserPreferences):
    """ """
    meta_type = 'ForumFolder'
    archetype_name = 'Forum Folder'

    schema = BaseSchema + Schema((
        StringField('title', required=1, default='Discussion Forums',
                    widget=StringWidget(label_msgid='label_title',
                                        description_msgid='help_title',
                                        i18n_domain='plone')),
        StringField('description', default='',
                    widget=TextAreaWidget(label_msgid='label_description',
                                          description_msgid='help_description',
                                          i18n_domain='plone')),
        ))


    allowed_content_types = ['ForumNB', 'ForumFolder']
    content_icon = 'fcFolder_icon.gif'

    _properties = (
        {'id': 'right_slots', 'type': 'lines', 'mode':'rwd'},
        )

    actions = (
            {'id': 'view',
             'name': 'View',
             'action': 'string:$object_url/forum_folder_view',
             'permissions': (View,)
             },
            )

    security = ClassSecurityInfo()

    right_slots = ()

    title = 'Discussion Forums'

    security.declareProtected(View, 'Title')
    def Title(self):
        """ """
        return self.getField('title').get(self)

    def initializeArchetype(self, **kwargs):
        if kwargs.has_key('uid'):
            setattr(self, UUID_ATTR, kwargs['uid'])
        
        OrderedBaseFolder.initializeArchetype(self, **kwargs)
        try:
            self.forum_folder_default_init()
        except:
            pass

    def manage_afterDelete(self, item, container):
        OrderedBaseFolder.manage_afterDelete(self, item, container)

        self._copy = 0

    def _notifyOfCopyTo(self, container=None, op=1):
        OrderedBaseFolder._notifyOfCopyTo(self, container, op)

        self._copy = 1

        for ob in self.objectValues():
            ob._notifyOfCopyTo(container, op)


registerType(ForumFolder)


def modify_fti(fti):
    for a in fti['actions']:
        if a['id'] in ('references',):
            a['visible'] = 0
    return fti
