# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz>
"""
$Id: __init__.py,v 1.6 2004/03/19 08:23:18 fafhrd91 Exp $
"""

from ExtensionClass import Base
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base, aq_inner

from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from Products.CMFCore.utils import getToolByName, _checkPermission

from ui_get_forum_data import \
     get_forum_data, get_forum_menu, get_forums_tree
from ui_get_topic_data import \
     get_topic_data, gen_thread, get_topic_menu
from ui_get_message_data import get_message_data


class UIHelpers(Base):
    """ """
    security = ClassSecurityInfo()

    security.declareProtected(View, 'getForumData')
    def getForumData(self, portal, member, basic=0):
        """ """
        return get_forum_data(aq_inner(self), portal, member, basic)

    security.declareProtected(View, 'getForumMenu')
    def getForumMenu(self, portal, member):
        """ """
        return get_forum_menu(aq_inner(self), portal, member)

    security.declareProtected(View, 'getTopicData')
    def getTopicData(self, message, portal, member):
        """ """
        return get_topic_data(
            aq_inner(self), message.getTopic(),
            aq_inner(message), portal, member)

    def getTopicMenu(self, message, portal, member):
        """ """
        return get_topic_menu(
            aq_inner(self), message.getTopic(),
            aq_inner(message), portal, member)

    security.declareProtected(View, 'getMessageData')
    def getMessageData(self, message, portal, member, actions=0):
        """ """
        data = get_message_data(
            aq_inner(self), aq_inner(message), portal, member, actions)

        view_mode = data['view_mode']
        if view_mode == 'full_thread':
            data['tree'] = self.genThreadTree(message, portal, member)
            data['replies_data'] = [data]
        elif view_mode == 'thread':
            data['tree'] = self.genThreadTree(message, portal, member)
            data['replies_data'] = [data]
        
        return data

    security.declareProtected(View, 'genThreadTree')
    def genThreadTree(self, message, portal, member, base=None, remove_first=0):
        """ """
        topic = message.getTopic()
        if base is None:
            base = topic

        return gen_thread(
            topic, base, message, portal.forumTime,
            member.getProperty('timezone',''), remove_first)

    security.declareProtected(View, 'genForumsTree')
    def genForumsTree(self):
        """ """
        return get_forums_tree(self.getForum())

InitializeClass(UIHelpers)
