# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz> 
"""
$Id: utils.py,v 1.12 2004/03/09 12:25:31 fafhrd91 Exp $
"""

import re
from Products.CMFCore.utils import getToolByName

try:
    from mx import Tidy
    mxTidyIsAvailable = 1
except ImportError:
    mxTidyIsAvailable = 0
    
    
from smiles import smiles

def forum_parser(self, content, emoticons=1):

    tmp_content = content

    # Miscellaneous html tags (presentation)
    tmp_content = tmp_content.replace('[b]','<b>')
    tmp_content = tmp_content.replace('[/b]','</b>')
    tmp_content = tmp_content.replace('[i]','<i>')
    tmp_content = tmp_content.replace('[/i]','</i>')
    tmp_content = tmp_content.replace('[big]','<span style="font-size:large;">')
    tmp_content = tmp_content.replace('[/big]','</span>')
    tmp_content = tmp_content.replace('[img]', '<img src="')
    tmp_content = tmp_content.replace('[/img]', '" border="0" />')
    tmp_content = tmp_content.replace('[blockquote]', '<blockquote>')
    tmp_content = tmp_content.replace('[/blockquote]', '</blockquote>')
    tmp_content = tmp_content.replace('[ol]', '<ol>')
    tmp_content = tmp_content.replace('[ul]', '<ul>')
    tmp_content = tmp_content.replace('[/ol]', '</ol>')
    tmp_content = tmp_content.replace('[/ul]', '</ul>')
    tmp_content = tmp_content.replace('[li]', '<li>')
    tmp_content = tmp_content.replace('[/li]', '</li>')

    # Unsupported/Nonstandard M$-style
    tmp_content = tmp_content.replace('[blink]','<blink>')
    tmp_content = tmp_content.replace('[/blink]','</blink>')
    tmp_content = tmp_content.replace('[u]','<u>')
    tmp_content = tmp_content.replace('[/u]','</u>')
    tmp_content = tmp_content.replace('[marquee]','<marquee>')
    tmp_content = tmp_content.replace('[/marquee]','</marquee>')

    # <a href tags..
    # Only convert if the url is well-formed, ignore otherwise
    url_check1 = '[url='
    url_check2 = ' urltitle='
    url_check3 = '][/url]'
    if tmp_content.find(url_check1) >= 0 \
           and tmp_content.find(url_check2) >= 0 \
           and tmp_content.find(url_check3) >= 0:
        tmp_content = tmp_content.replace(
            '[url=', '<a target="_blank" title="External Link" href="')
        tmp_content = tmp_content.replace(' urltitle=', '">')
        tmp_content = tmp_content.replace('][/url]', '</a>')
        
    # Code tags, I am not converting straight [code] to <code>
    # since I need the paragraph break that <pre> gives, suit this
    # to your needs
    tmp_content = tmp_content.replace('[code]', '<pre>')
    tmp_content = tmp_content.replace('[/code]', '</pre>')

    if hasattr(self, 'fcEmoticons'):
        img_path = self.fcEmoticons.absolute_url()
        img_folder = self.fcEmoticons
        if emoticons:
            for sm, sm_img in smiles:
                tmp_content = tmp_content.replace(
                    sm, getattr(img_folder, sm_img).tag())

    return tmp_content


# word-wrap function that preserves line breaks and spaces
# (from http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/148061)
def wrap(s, width=72):
    return reduce(lambda line, word, width=width: '%s%s%s' %
                  (line,
                   ' \n'[(len(line[line.rfind('\n')+1:])
                          + len(word.split('\n',1)[0]
                                ) >= width)],
                   word),
                  s.split(' ')
                  )


def forum_stateChanged(sci):
    sci.object.notifyStateChanged(sci)


# Regexp for snipping the body of a document
HTML_BODY = re.compile('<body[^>]*?>(.*)</body[^>]*?>', re.DOTALL|re.IGNORECASE)

def forum_html_tidy(self, html):
    """ """
    errors = 0
    output = html
    errordata = ""

    if mxTidyIsAvailable:
        input = html.encode('utf-8')
        
        (errors, warnings, output, errordata) = Tidy.tidy(
            input,
            drop_font_tags=1,
            drop_empty_paras=1,
            indent_spaces=0,
            indent='no',
            output_xhtml=1,
            word_2000=1,
            wrap=65,
            char_encoding='utf8')

        output = unicode(output, 'utf-8')

        if errors:
            output = html

    result = HTML_BODY.search(output)
    if result:
        output = result.group(1).strip()

    return (errors, output, errordata)

